<?php

// error_reporting(E_ALL);

/**
 * Back-end of ExLink .
 *
 * Copyright (c) 2012 Lubomyr Kudray (http://codestore.netii.net/)
 */

if( ! defined('CMSIMPLE_XH_VERSION'))
{
  header('HTTP/1.0 403 Forbidden');
  exit;
}

function exlink_version()
{
  global $pth,$ptx,$plugin_tx;

  $ptx = $plugin_tx['exlink'];
  return '<h1><a href="http://bookstore.comoj.com/" target="_blank">' . EXLINK_NAME . '</a></h1>' . "\n"
    . tag('img src="' . $pth['folder']['plugins'] . 'exlink/exlink.png" class="exlink_plugin_icon"')
    . '<p>Version: ' . EXLINK_VERSION . tag('br') . "\n"
    . 'Copyright &copy; 2012 <a href="http://codestore.netii.net/">Lubomyr Kudray</a></p>'
    . '<p>Optimise external links for SEO with ExLink_XH plugin.</p>' . "\n"
    . '<p>Further features are explained in a <a href="' . $pth['folder']['plugins'] . 'exlink/help/help.htm" target="_blank">help</a>.</p>'
    . 'Huge thanks to <a href="http://3-magi.net/">Christoph M. Becker</a>.</p>'
    . tag('br') . "\n"
    . tag('hr')
    . '<p class="distributes">This program is free software: you can redistribute it and/or modify'
    . ' it under the terms of the GNU General Public License as published by'
    . ' the Free Software Foundation, either version 3 of the License, or'
    . ' (at your option) any later version.</p>' . "\n"
    . '<p class="distributes">This program is distributed in the hope that it will be useful,'
    . ' but WITHOUT ANY WARRANTY; without even the implied warranty of'
    . ' MERCHAN&shy;TABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the'
    . ' GNU General Public License for more details.</p>' . "\n"
    . '<p class="distributes">You should have received a copy of the GNU General Public License'
    . ' along with this program.<br />If not, see'
    . ' <a href="http://www.gnu.org/licenses/">http://www.gnu.org/licenses/</a>.</p>' . "\n"
    . '<p class="warranty">there is NO WARRANTY for the program, to the extent permitted by applicable'
    . ' law. except when otherwise stated in writing the copyright holders and/or other parties provide'
    . ' the program "as is" without warranty of any kind, either expressed or implied, including,'
    . ' but not limited to, the implied warranties of merchantability and fitness for a particular'
    . ' purpose. the entire risk as to the quality and performance of the program is with you.'
    . ' should the program prove defective, you assume the cost of all necessary servicing,'
    . ' repair or correction.</p>';
}

/**
 * Returns requirements information view.
 *
 * @return string  The (X)HTML.
 */
function exlink_system_check()
{
  global $pth, $tx, $plugin_tx, $plugin_cf;
  define('EXLINK_PHP_VERSION', '5.4.4');
  $ptx = $plugin_tx['exlink'];
  $imgdir = $pth['folder']['plugins'] . 'exlink/images/';
  $ok = tag('img src="' . $imgdir . 'ok.png" alt="ok"');
  $warn = tag('img src="' . $imgdir . 'warn.png" alt="warning"');
  $fail = tag('img src="' . $imgdir . 'fail.png" alt="failure"');
  $o = tag('hr') . '<h4>' . $ptx['syscheck_title'] . '</h4>'
    . (version_compare(PHP_VERSION, EXLINK_PHP_VERSION) >= 0? $ok: $fail)
    . '&nbsp;&nbsp;' . sprintf($ptx['syscheck_phpversion'], EXLINK_PHP_VERSION)
    . tag('br') . tag('br');
  foreach(array() as $ext) {
    $o .= (extension_loaded($ext)? $ok: $fail)
       . '&nbsp;&nbsp;' . sprintf($ptx['syscheck_extension'], $ext) . tag('br');
  }
  $o .= (strtoupper($tx['meta']['codepage']) == 'UTF-8'? $ok: $warn)
    . '&nbsp;&nbsp;' . $ptx['syscheck_encoding'] . tag('br');
  $o .= ( ! get_magic_quotes_runtime()? $ok: $warn)
    . '&nbsp;&nbsp;' . $ptx['syscheck_magic_quotes'] . tag('br')
	. (file_exists($pth['folder']['plugins'] . 'jquery/jquery.inc.php') ? $ok : $fail)
	. '&nbsp;&nbsp;' . $ptx['syscheck_jquery'] . tag('br') . tag('br');
	$folders = array();
  foreach(array('config/', 'css/', /* 'data', */ 'languages/') as $folder) {
    $folders[] = $pth['folder']['plugins'] . 'exlink/' . $folder;
  }
  foreach($folders as $folder) {
    $o .= (is_writable($folder)? $ok: $warn)
      . '&nbsp;&nbsp;' . sprintf($ptx['syscheck_writable'], $folder) . tag('br');
  }
  return $o;
}

/**
 * Handle the plugin administration.
 */
if(isset($exlink) && $exlink == 'true')
{
  $ERROR = '';
  $plugin = basename(dirname(__FILE__), "/");
  $o .= print_plugin_admin('off');

  switch($admin)
  {
    case '': $o .= exlink_version() . exlink_system_check();
    break;
//    case 'plugin_main':
/* no plugin body */
//    break;
    default:
      $o .= plugin_admin_common($action, $admin, $plugin);
  }
}

?>